*--------*---------*---------*---------*---------
*  Program...........: BRARRAY.PRG
*  System............: BrArray
*  Author............: Stephen A. Sawyer
*  Date..............: September 22, 1994
*  Notice............: Copyright (c) 1994
*  ..................: KarCal Company, Inc.
*  Compiler..........: FoxPro 2.6 for Windows
*) Description.......: This procedure is a development
*) ..................: tool that allows viewing of
*) ..................: the contents of an array
*) ..................: The procedure converts
*) ..................: all array contents to character
*) ..................: data, and stuffs the result
*) ..................: into a cursor which is BROWSEd
*  Syntax............: DO BrArray WITH <array name>
*  Parameters........: paArray - Array to display
*  Uses..............:
*  Returns...........:
*  Calls.............:
*  Changes...........:
*  Called By.........:
*--------*---------*---------*---------*---------
* PROCEDURE BrArray
PARAMETERS paArray
PRIVATE ALL j*
jnElements=ALEN(paArray)
jnRow=ASUBSCRIPT(paArray,jnElements,1)
jnLast=jnElements/jnRow
IF jnRow = jnElements
	jnCol = 1
	* This is a "kludge" to allow referencing
	* a one-dimensional array using row-and
	* column subscripts - don't ask me why it
	* works!
	DIMENSION paArray[jnLast,1]
ELSE	
	jnCol=ASUBSCRIPT(paArray,jnLast,2)
ENDIF
DIMENSION jaDisp[jnRow,jnCol]
STORE "" to jaDisp

FOR ji = 1 to jnRow
	FOR jj = 1 to jnCol
		DO CASE
		CASE TYPE("paArray[ji,jj]") = "C"
			jaDisp[ji,jj] = paArray[ji,jj]
		CASE TYPE("paArray[ji,jj]") = "N"
			jaDisp[ji,jj] = LTRIM(STR(paArray[ji,jj],10,4))
		CASE TYPE("paArray[ji,jj]") = "D"
			jaDisp[ji,jj] = DTOC(paArray[ji,jj])
		CASE TYPE("paArray[ji,jj]") = "L"
			jaDisp[ji,jj] = IIF(paArray[ji,jj],".T.",".F.")
		OTHERWISE
			jaDisp[ji,jj] = "Unknown"
		ENDCASE
	ENDFOR &&* jj = 1 to jnCol
ENDFOR &&* ji = 1 to jnRow
jcCreate = ""
FOR jj = 1 to jnCol
	jnMax = 0
	FOR ji = 1 to jnRow
		jnMax = MAX(jnMax,LEN(ALLTRIM(jaDisp[ji,jj])))
	ENDFOR &&* ji = 1 to jnRow
	jcCreate = jcCreate + "Col_" + LTRIM(STR(jj)) + " C(" + LTRIM(STR(jnMax)) + "), " 
ENDFOR &&* jj = 1 to jnCol
jcCreate = "CREATE CURSOR array (ROW N(5), " + LEFT(jcCreate,LEN(jcCreate)-2) + ")"
jcCurrArea = ALIAS()
&jcCreate
FOR ji = 1 TO jnRow
	SELECT array
	APPEND BLANK
	REPLACE row WITH ji
	FOR jj = 1 TO jnCol
		REPLACE (FIELD(jj + 1)) WITH jaDisp[ji,jj]
	ENDFOR &&* jj = 1 TO jnCol
ENDFOR &&* ji = 1 TO jnRow
DEFINE WINDOW array FROM 0,0 TO 10,60 SYSTEM CLOSE COLOR SCHEME 10
MOVE WINDOW array CENTER
BROWSE WINDOW array NOMODIFY NOAPPEND NOMENU 
USE
IF ! EMPTY(jcCurrArea)
	SELECT (jcCurrArea)
ENDIF	